#include "stdafx.h"

#include "MovableDialog.h"

CMovableDialog::CMovableDialog( )
:CDialog()
{
}

CMovableDialog::CMovableDialog( UINT nIDTemplate, CWnd* pParentWnd/* = NULL */)
: CDialog(nIDTemplate,pParentWnd)
{
}

CMovableDialog::CMovableDialog( LPCTSTR lpszTemplateName, CWnd* pParentWnd/* = NULL */)
: CDialog(lpszTemplateName,pParentWnd)
{
}

void CMovableDialog::InitMovableDialog(int resizingArea,bool centerRest)
{
	CRect rc;
	GetClientRect(rc);

	m_intW=rc.Width();
	m_intH=rc.Height();
	m_idResizingArea=resizingArea;
	m_bCenterRest=centerRest;

	::EnumChildWindows(GetSafeHwnd(),EnumControlsProc,(LPARAM) this);
}

void CMovableDialog::ApplyMovableDialog(int w,int h)
{
	HWND resizingArea;
	GetDlgItem(m_idResizingArea,&resizingArea);

	for (std::vector< std::pair<HWND,RECT> >::iterator it=m_vControls.begin();it!=m_vControls.end();it++) {
		std::pair<HWND,RECT> p=*it;

		if (p.first==resizingArea) { //resize
			p.second.right+=w-m_intW;
			p.second.bottom+=h-m_intH;
		} else if (m_bCenterRest) { //shift right & down
			p.second.left+=w-m_intW;
			p.second.right+=w-m_intW;
			p.second.top+=(h-m_intH)/2;
			p.second.bottom+=(h-m_intH)/2;
		} else {//shift right & down
			p.second.left+=0;
			p.second.right+=w-m_intW;
			p.second.top+=h-m_intH;
			p.second.bottom+=h-m_intH;
		}

		WINDOWPLACEMENT wp;
		::ZeroMemory(&wp,sizeof(wp));
		wp.length=sizeof(wp);
		wp.rcNormalPosition=p.second;
		wp.showCmd=SW_SHOW;
		::SetWindowPlacement(p.first,&wp);
	}
	Invalidate();
}

BOOL CALLBACK CMovableDialog::EnumControlsProc(HWND hwnd,LPARAM lParam)
{
	CMovableDialog* dlg=(CMovableDialog *)lParam;
	WINDOWPLACEMENT wp;
	::ZeroMemory(&wp,sizeof(wp));
	wp.length=sizeof(wp);
	::GetWindowPlacement(hwnd,&wp);
	
	dlg->m_vControls.push_back(std::pair<HWND,RECT>(hwnd,wp.rcNormalPosition));

	return TRUE;
}